diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/sixlowpan/bindings/modulegen__gcc_LP64.py ns-3.33/src/sixlowpan/bindings/modulegen__gcc_LP64.py
--- ns-3.32/src/sixlowpan/bindings/modulegen__gcc_LP64.py	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/sixlowpan/bindings/modulegen__gcc_LP64.py	2021-01-09 10:19:22.000000000 -0800
@@ -5874,12 +5889,12 @@
     cls.add_method('GetTypeid', 
                    'std::string', 
                    [], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::SixLowPanNetDevice::DropReason, ns3::Ptr<const ns3::Packet>, ns3::Ptr<ns3::SixLowPanNetDevice>, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::SixLowPanNetDevice::DropReason arg0, ns3::Ptr<const ns3::Packet> arg1, ns3::Ptr<ns3::SixLowPanNetDevice> arg2, unsigned int arg3) [member operator]
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::SixLowPanNetDevice::DropReason', 'arg0'), param('ns3::Ptr< ns3::Packet const >', 'arg1'), param('ns3::Ptr< ns3::SixLowPanNetDevice >', 'arg2'), param('unsigned int', 'arg3')], 
-                   is_virtual=True, is_pure_virtual=True, custom_name='__call__')
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3HashImplementation_methods(root_module, cls):
@@ -5891,7 +5906,7 @@
     cls.add_method('GetHash32', 
                    'uint32_t', 
                    [param('char const *', 'buffer'), param('std::size_t const', 'size')], 
-                   is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_virtual=True)
     ## hash-function.h (module 'core'): uint64_t ns3::Hash::Implementation::GetHash64(char const * buffer, std::size_t const size) [member function]
     cls.add_method('GetHash64', 
                    'uint64_t', 
@@ -5901,7 +5916,7 @@
     cls.add_method('clear', 
                    'void', 
                    [], 
-                   is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3HashFunctionFnv1a_methods(root_module, cls):
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/sixlowpan/model/sixlowpan-net-device.cc ns-3.33/src/sixlowpan/model/sixlowpan-net-device.cc
--- ns-3.32/src/sixlowpan/model/sixlowpan-net-device.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/sixlowpan/model/sixlowpan-net-device.cc	2021-01-09 10:19:22.000000000 -0800
@@ -335,10 +335,20 @@
       }
       break;
     case SixLowPanDispatch::LOWPAN_HC1:
+      if (m_useIphc)
+        {
+          m_dropTrace (DROP_DISALLOWED_COMPRESSION, copyPkt, m_node->GetObject<SixLowPanNetDevice> (), GetIfIndex ());
+          return;
+        }
       DecompressLowPanHc1 (copyPkt, realSrc, realDst);
       isPktDecompressed = true;
       break;
     case SixLowPanDispatch::LOWPAN_IPHC:
+      if (!m_useIphc)
+        {
+          m_dropTrace (DROP_DISALLOWED_COMPRESSION, copyPkt, m_node->GetObject<SixLowPanNetDevice> (), GetIfIndex ());
+          return;
+        }
       DecompressLowPanIphc (copyPkt, realSrc, realDst);
       isPktDecompressed = true;
       break;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/sixlowpan/model/sixlowpan-net-device.h ns-3.33/src/sixlowpan/model/sixlowpan-net-device.h
--- ns-3.32/src/sixlowpan/model/sixlowpan-net-device.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/sixlowpan/model/sixlowpan-net-device.h	2021-01-09 10:19:22.000000000 -0800
@@ -70,9 +70,10 @@
    */
   enum DropReason
   {
-    DROP_FRAGMENT_TIMEOUT = 1, /**< Fragment timeout exceeded */
-    DROP_FRAGMENT_BUFFER_FULL, /**< Fragment buffer size exceeded */
-    DROP_UNKNOWN_EXTENSION /**< Unsupported compression kind */
+    DROP_FRAGMENT_TIMEOUT = 1,   /**< Fragment timeout exceeded */
+    DROP_FRAGMENT_BUFFER_FULL,   /**< Fragment buffer size exceeded */
+    DROP_UNKNOWN_EXTENSION,      /**< Unsupported compression kind */
+    DROP_DISALLOWED_COMPRESSION  /**< HC1 while in IPHC mode or viceversa */
   };
 
   /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/sixlowpan/test/example-ping-lr-wpan.reflog ns-3.33/src/sixlowpan/test/example-ping-lr-wpan.reflog
--- ns-3.32/src/sixlowpan/test/example-ping-lr-wpan.reflog	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/sixlowpan/test/example-ping-lr-wpan.reflog	2021-01-09 10:19:22.000000000 -0800
@@ -1,6 +1,6 @@
-Device 0: pseudo-Mac-48 02:01:00:00:00:01, IPv6 Address 2001:2::1:ff:fe00:1
-Device 1: pseudo-Mac-48 02:01:00:00:00:02, IPv6 Address 2001:2::1:ff:fe00:2
-NDISC Cache of node 0 at time 9
-2001:2::1:ff:fe00:2 dev 2 lladdr 00-06-02:01:00:00:00:02 REACHABLE
-NDISC Cache of node 1 at time 9
-2001:2::1:ff:fe00:1 dev 2 lladdr 00-06-02:01:00:00:00:01 REACHABLE
+Device 0: pseudo-Mac-48 02:00:00:00:00:01, IPv6 Address 2001:2::ff:fe00:1
+Device 1: pseudo-Mac-48 02:00:00:00:00:02, IPv6 Address 2001:2::ff:fe00:2
+NDISC Cache of node 0 at time +9s
+2001:2::ff:fe00:2 dev 2 lladdr 00-06-02:00:00:00:00:02 REACHABLE
+NDISC Cache of node 1 at time +9s
+2001:2::ff:fe00:1 dev 2 lladdr 00-06-02:00:00:00:00:01 REACHABLE
